/****************************************************************************
    This file is part of TIImageTool.

    TIImageTool is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    TIImageTool is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with TIImageTool.  If not, see <http://www.gnu.org/licenses/>.
    
    Copyright 2011 Michael Zapf
    www.mizapf.de
    
****************************************************************************/
package ti.image;

import javax.swing.*;
import java.awt.event.InputEvent;

abstract class Activity {
	
	protected JFrame m_parent;
	protected TIImageTool imagetool;
	
	public void setLinks(TIImageTool timt, JFrame parent) {
		m_parent = parent;
		imagetool = timt;
	}
	
	public abstract String getMenuName();
	public abstract String getActionName();
	
	public abstract void go();

	public int getKeyCode() {
		return 0;
	}

	public int getModifier() {
		return InputEvent.CTRL_DOWN_MASK;
	}
}
