/****************************************************************************
    This file is part of TIImageTool.

    TIImageTool is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    TIImageTool is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with TIImageTool.  If not, see <http://www.gnu.org/licenses/>.
    
    Copyright 2011 Michael Zapf
    www.mizapf.de
    
****************************************************************************/
package ti.util;
import java.io.*;

public class CreateHeadered {
	
	public static void main(String[] arg) {
		if (arg.length < 5) {
			System.err.println("Usage: CreateHeadered <src> <target> <offset> <length> <start>");
			return;
		}
			
		String sSource = arg[0];
		String sTarget = arg[1];
		int nOffset = Integer.parseInt(arg[2]);
		int nLength = Integer.parseInt(arg[3]);
		int nStartAddress = Integer.parseInt(arg[4], 16);

		try {
			// Open the file (name arg[0])
			DataInputStream dis = new DataInputStream(new FileInputStream(sSource));
			byte[] abySource = new byte[dis.available()];
			dis.readFully(abySource);
			dis.close();
			
			// Put the header at the beginning (address arg[2])
			byte[] abyNew = new byte[nLength+6];
			abyNew[0] = (byte)0;
			abyNew[1] = (byte)0;
			abyNew[2] = (byte)((nLength/256)&0xff);
			abyNew[3] = (byte)(nLength&0xff);
			abyNew[4] = (byte)((nStartAddress/256)&0xff);
			abyNew[5] = (byte)(nStartAddress&0xff);
			System.arraycopy(abySource, nOffset, abyNew, 6, nLength);
			
			FileOutputStream fos = new FileOutputStream(sTarget);
			fos.write(abyNew);
			fos.close();
		}
		catch (IOException iox) {
			iox.printStackTrace();
		}
	}
}
