/****************************************************************************
    This file is part of TIImageTool.

    TIImageTool is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    TIImageTool is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with TIImageTool.  If not, see <http://www.gnu.org/licenses/>.
    
    Copyright 2011 Michael Zapf
    www.mizapf.de
    
****************************************************************************/

package ti.util;
import java.io.IOException;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.RandomAccessFile;
import java.io.File;
import java.nio.ByteBuffer;
import java.nio.file.Path;
import java.nio.channels.FileChannel;
import java.nio.file.StandardOpenOption;

public class RawAccess {
	
	Path m_path;
	String m_sPath;
	
	public static void main(String[] arg)
	{
		System.out.print("Enter device: ");
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		try {
			String input = br.readLine();
			System.out.println(input);
			RawAccess ra = new RawAccess(input);
			ra.go();
		}
		catch (IOException iox) {
			iox.printStackTrace();
		}
	}
	
	RawAccess(String dev) {
		File fl = new File(dev);
		m_sPath = dev;
		m_path = fl.toPath();
		System.out.println("File system = " + m_path.getFileSystem());
	}
	
	void go() throws IOException {	
		//FileChannel fc = FileChannel.open(m_path, StandardOpenOption.READ, StandardOpenOption.WRITE);
		RandomAccessFile raf = new RandomAccessFile(m_sPath, "rw");
		FileChannel fc = raf.getChannel();
		ByteBuffer bb = ByteBuffer.allocate(512);
		fc.position(0);
		fc.read(bb);
		byte[] sect0 = bb.array();
		System.out.println(Utilities.hexdump(sect0));

		System.out.print("Ready to write (enter WRITE): ");
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		String input = br.readLine();

		if (input.equals("WRITE")) {
			if (sect0[0xe0] == 0x00) {
				sect0[0xe0] = (byte)'M';
				sect0[0xe1] = (byte)'Z';
			}
			else {
				sect0[0xe0] = (byte)0x00;
				sect0[0xe1] = (byte)0x00;
			}
			sect0[0xe2] = (byte)((sect0[0xe2]+1) & 0xff);
			fc.position(0);
			int number = 0;
			bb.rewind();
			
			while (bb.remaining()>0) {
				number += fc.write(bb);
				System.out.println("Wrote " + number + " bytes");
			}			
		}		
		fc.close();
	}
}

